ArrowBase = ArrowBase or class(ProjectileBase)
ArrowBase._arrow_units = {}
local mvec1 = Vector3()
local mrot1 = Rotation()
local ids_pickup = Idstring("pickup")

function ArrowBase:_on_collision(col_ray)
	self._ext_damage = managers.player:player_unit():character_damage()
	local damage_mult = self._weapon_damage_mult or 1
	local health_ratio = self._ext_damage:health_ratio()
	local damage_health_ratio = managers.player:get_damage_health_ratio(health_ratio, weapon_category)
	local equipped_weapon_category = managers.player:get_equipped_weapon_category()
	
	if equipped_weapon_category == "bow" then
		if damage_health_ratio > 0 then
			damage_mult = damage_mult * (1 + managers.player:upgrade_value("player", "damage_health_ratio_multiplier", 0) * damage_health_ratio)
		end
		if managers.player:has_category_upgrade("player", "overkill_all_weapons") then
			damage_mult = damage_mult * managers.player:temporary_upgrade_value("temporary", "overkill_damage_multiplier", 1)
		end		
	end
	
	local loose_shoot = self._weapon_charge_fail
	if not loose_shoot and alive(col_ray.unit) then
		local client_damage = self._damage_class_string == "InstantExplosiveBulletBase" or alive(col_ray.unit) and col_ray.unit:id() ~= -1
		if Network:is_server() or client_damage then
			self._damage_class:on_collision(col_ray, self._weapon_unit or self._unit, self._thrower_unit, self._damage * damage_mult, false, false)
		end
	end
	if not loose_shoot and tweak_data.projectiles[self._tweak_projectile_entry].remove_on_impact then
		self._unit:set_slot(0)
		return
	end
	self._unit:body("dynamic_body"):set_deactivate_tag(Idstring())
	self._col_ray = col_ray
	self:_attach_to_hit_unit(nil, loose_shoot)
end